using System;
using System.Data;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Text.RegularExpressions;

namespace matome {

    class Matome {
        private static string ANCHOR_PATTERN="";
        private static string RES_PATTERN = "";
        private static int logCount = 1;
        private static Boolean TagMode = true;
        private static Boolean AppendMode = true;
        //@gїE҂͑̐l̂̂܂ŏEčƂɂȂ\̂ł߂܂B
        // oɑΏۗE҂̓ID擾
        // ́@с@t ID
        // f[^擾(E҂̔̂)
        // N擾
        // HTMLo
        // I
        public static int Main(string[] args) {
            Boolean ret = true;

            Brave brave = new Brave();
            if (args.Length < 1) {
                //EҖȗ͗EҖݒt@CɏĂƂ͂Ō
                string braveName = System.Configuration.ConfigurationSettings.AppSettings["BRAVE_NAME"].Trim();
                if (braveName==null || braveName.Equals("")) {
                    Console.WriteLine("Usage : Matome EҖ ");
                    return 1;
                }
                brave.Name = braveName;
            } else {
                brave.Name = args[0];
            }
            //K\ǂݍ
            ANCHOR_PATTERN=System.Configuration.ConfigurationSettings.AppSettings["ANCHOR_PATTERN"];
            RES_PATTERN = System.Configuration.ConfigurationSettings.AppSettings["RES_PATTERN"];
            //^O[h TRUE:ʏo FALSE:Xo͂Ȃ[h
            TagMode = System.Configuration.ConfigurationSettings.AppSettings["TAG_MODE"].Equals("TRUE");
            //㏑[h TRUE:Sēt@Cɏo͂郂[h FALSE:ʃt@Cɏo͂郂[h
            AppendMode = System.Configuration.ConfigurationSettings.AppSettings["APPEND_MODE"].Equals("TRUE");
        
            
            //ΏTRIPǍ
            for (int i = 0; i < int.Parse(ConfigurationSettings.AppSettings["BRAVE_TRIP_COUNT"]); i++) {
                brave.Trips.Add(ConfigurationSettings.AppSettings["BRAVE_TRIP_" + i]);
            }

            //ΏIDǍ
            for (int i = 0; i < int.Parse(ConfigurationSettings.AppSettings["BRAVE_ID_COUNT"]); i++) {
                brave.IDs.Add(ConfigurationSettings.AppSettings["BRAVE_ID_" + i]);
            }

            //U҂̂ꍇΏۊOTRIPǍ
            for (int i = 0; i < int.Parse(ConfigurationSettings.AppSettings["NOT_BRAVE_TRIP_COUNT"]); i++) {
                brave.DummyTrips.Add(ConfigurationSettings.AppSettings["NOT_BRAVE_TRIP_" + i]);
            }

            //U҂̂ꍇΏۊOIDǍ
            for (int i = 0; i < int.Parse(ConfigurationSettings.AppSettings["NOT_BRAVE_ID_COUNT"]); i++) {
                brave.DummyIDs.Add(ConfigurationSettings.AppSettings["NOT_BRAVE_ID_" + i]);
            }

            // oɑΏۗE҂̓ID擾
            string path = ConfigurationSettings.AppSettings["FOLDER_PATH"];
            string targetPath = path;
          
            string[] workDirectorys;
            //TutH_邩  TRUE:TutH_Ώ FALSE:wtH_܂
            Boolean subFolderSearchMode = System.Configuration.ConfigurationSettings.AppSettings["FOLDER_SEARCH_MODE"].Equals("TRUE");
            if (subFolderSearchMode) {
                workDirectorys = Directory.GetDirectories(targetPath, "*", SearchOption.AllDirectories);
            } else {
                workDirectorys = Directory.GetDirectories(targetPath);
            }
            //      Console.WriteLine("ΏۃtH_ : {0}",targetPath);
            //      Console.WriteLine("tH_ : {0}",workDirectorys.Length);

            //IDW[h ALL USWネO@ȊOtH_̂ݎ擾
            Boolean idMode = System.Configuration.ConfigurationSettings.AppSettings["ID_MODE"].Equals("ALL");
            //Log[h TRUE Ȃ胍Ó@ȊOсAID㏈
            Boolean logMode = System.Configuration.ConfigurationSettings.AppSettings["LOG_MODE"].Equals("TRUE");
            //̌[h START/IN/ALL/END
            string nameMode = System.Configuration.ConfigurationSettings.AppSettings["NAME_MODE"];

            //tH_Kwꍇ
            if (workDirectorys.Length > 0) {
                for (int i = 0; ret && i < workDirectorys.Length; i++) {
                    if (!logMode) {
                        getLogByFolder(workDirectorys[i], brave, true, nameMode);
                    }
                    if (!idMode) {
                        getLogByFolder(workDirectorys[i], brave, false, nameMode);
                    }
                }
                if (idMode) {
                    for (int i = 0; ret && i < workDirectorys.Length; i++) {
                        getLogByFolder(workDirectorys[i], brave, false, nameMode);
                    }
                }
            } else {    //PtH_̏ꍇ
                if (!logMode) {
                    getLogByFolder(targetPath, brave, true, nameMode);
                }
                getLogByFolder(targetPath, brave, false, nameMode);
            }
            /* foOpΏۓтIDo * /
            if(brave.Trips.Count>0){
              for(int i=0;i<brave.Trips.Count;i++){
                Console.WriteLine("{0}",brave.Trips[i]);
              }
              //Console.WriteLine("{0} : {1},{2}",i+1 ,trip,matchCol[0].Groups[3]);
            }
            if(brave.IDs.Count>0){
              for(int i=0;i<brave.IDs.Count;i++){
                Console.WriteLine("ID:{0}",brave.IDs[i]);
              }
            }
            /* foO܂ */
            // ́@с@t ID
            // f[^擾(E҂̔̂)
            // N擾
            // HTMLo
            //cssRs[
            string outPath = ConfigurationSettings.AppSettings["OUT_PATH"];
            if (outPath == null || outPath.Equals("")) {
                outPath = ".";
            }
            if (!Directory.Exists(outPath)) {
                outPath = ".";
            }
            if (!File.Exists(outPath + "/" + ConfigurationSettings.AppSettings["CSS_FILE"])) {
                System.IO.File.Copy(ConfigurationSettings.AppSettings["CSS_FILE"], outPath + "/" + ConfigurationSettings.AppSettings["CSS_FILE"]);
            }
            // I
            Console.WriteLine("-------------------------------------- I");
            return 0;
        }
        /**
         * getLogByFolder
         * tH_z̃t@Cɑ΂ďsB
         * :tH_pX(I)
         * @@:Eҏ(I/O)
         *     :[h(True:юW False:OW)
         * @@:̌[h(I)
         * ߂l:(True/False)
        */
        private static bool getLogByFolder(string pFolderPath, Brave brave,bool mode,string nameMode) {
            Console.WriteLine("tH_ : {0}",pFolderPath);
            bool ret = true;
            //tH_z̃t@C擾
            System.IO.DirectoryInfo dirInfo = new System.IO.DirectoryInfo(pFolderPath);
            //tH_datt@Cꗗ
            foreach (System.IO.FileInfo file in dirInfo.GetFiles("*.dat")) {
                if (mode) {
                    Console.WriteLine("\tt@C : {0} o", file.Name);
                    if (!executeForName(file, brave, nameMode)) {
                        ret = false;
                    }
                } else {
                    Console.WriteLine("\tt@C : {0} ", file.Name);
                    Sure wSure;
                    if ((wSure = executeForTripID(file, brave, nameMode)).flag==1) {
                        //HTMLo
                        Console.WriteLine("\tt@C : {0} o͒", file.Name);
                        OutHtml(file, brave, wSure);
                    } else {
                        ret = false;
                    }
                }
                //eXgŏ̃t@CŎ~߂ꍇ̓RgO
                //break;
            }
            return ret;
        }
        /**
         * executeForName
         * сAIDo
         * Eҏ̖̂ɗEҏ̓тID𖄂߂
         * :tH_pX(I)
         * @@:Eҏ(I/O)
         * @@:̌[h(I)
         * ߂l:(True/False)
         */
        private static Boolean executeForName(FileInfo pInfo, Brave brave,string nameMode) {
            Boolean ret = true;
            try {
                string sure = ReadFile(pInfo);
                string[] result = sure.Split('\n');
                for (int i = 0; i < result.Length; i++) {
                    if (result[i].Trim() != "") {
                        //O(Trip)<>[<> ID<>{<>X^C(sڂ̂)
                        Regex regex = new System.Text.RegularExpressions.Regex(RES_PATTERN);
                        MatchCollection matchCol = regex.Matches(result[i].Trim());
                        //`Ă珈
                        if (matchCol.Count > 0) {
                            string name = matchCol[0].Groups[1].Value.Trim();
                            //^O͏
                            name = name.Replace("<b>", "").Replace("</b>", "").Trim();
                            string trip = "";
                            //`<b> Trip𒊏o
                            if (name.IndexOf("") >= 0) {
                                trip = name;
                                trip = trip.Substring(trip.IndexOf("") + 1, trip.Length - trip.IndexOf("") - 1);
                                trip = trip.Trim();
                                name = name.Substring(0, name.IndexOf("")).Trim();
                            }
                            //O̗EҖ͂܂Ăꍇ܂͓тvꍇ
                            //̃[hΉ
                            if (trip!=null && !trip.Equals("") && brave.Trips.Contains(trip)
                                || (nameMode.Equals("START") && name.StartsWith(brave.Name))
                                || (nameMode.Equals("IN") && name.IndexOf(brave.Name)>=0)
                                || (nameMode.Equals("ALL") && name.Equals(brave.Name))
                                || (nameMode.Equals("END") && name.EndsWith(brave.Name))
                                    ) {
                                //IDo
                                string dateId = matchCol[0].Groups[3].Value.Trim();
                                string id = dateId.Substring(dateId.IndexOf("ID:") + 3).Trim();
                                //UғуXgɂΏO
                                if (brave.DummyTrips.Contains(trip)) {
                                    continue;
                                }
                                //UIDXgɂΏO
                                if (brave.DummyIDs.Contains(id)) {
                                    continue;
                                }
                                //Console.WriteLine("H:{0}",trip);
                                //\̂ɑ݂ȂΒǉ
                                if (!brave.Trips.Contains(trip)) {
                                    brave.Trips.Add(trip);
                                }
                                //\̂ɑ݂ȂΒǉ
                                if (!brave.IDs.Contains(id)) {
                                    brave.IDs.Add(id);
                                }
                                //Console.WriteLine("{0} : {1},{2}",i+1 ,trip,matchCol[0].Groups[3]);
                            }
                        }
                    }
                }

            } catch (Exception e) {
                Console.WriteLine("Exception StackTrace = {0}", e.StackTrace);
                ret = false;
            } finally {
            }
            return ret;
        }
        /**
         * executeForTripID
         * сAIDo
         * Eҏ̓сAIDɗE҂̔ƃN撊oHTMLo
         * :tH_pX(I)
         * @@:Eҏ(I/O)
         * @@:̌[h(I)
         * ߂l:Xbh\
         */
        private static Sure executeForTripID(FileInfo pInfo, Brave brave, string nameMode) {
            Sure wSure = new Sure();
            try {
                //t@CǍ
                string sure = ReadFile(pInfo);

                //sPʂŕ[v
                string[] result = sure.Split('\n');
                for (int i = 0; i < result.Length ; i++) {
                    //sȊOȂ珈
                    if (result[i].Trim() != "") {
                        //O(Trip)<>[<> ID<>{<>X^C(sڂ̂)
                        Regex regex = new System.Text.RegularExpressions.Regex(RES_PATTERN);
                        MatchCollection matchCol = regex.Matches(result[i].Trim());
                        //`Ă珈
                        if (matchCol.Count > 0) {
                            //擪sȂX^C擾
                            if (i == 0) {
                                wSure.Title = matchCol[0].Groups[5].Value.Trim();
                            }

                            Res wRes = new Res();
                            //XԂ̓[vϐ+1([vϐ0͂܂邽)
                            wRes.No = i + 1;
                            //Oo
                            wRes.Name = matchCol[0].Groups[1].Value.Trim();
                            wRes.Name = wRes.Name.Replace("<b>", "").Replace("</b>", "");
                            //` Trip𒊏o
                            if (wRes.Name.IndexOf("") >= 0) {
                                string trip = wRes.Name;
                                trip = trip.Substring(trip.IndexOf("") + 1, trip.Length - trip.IndexOf("") - 1);
                                wRes.Trip = trip.Trim();
                                wRes.Name = wRes.Name.Substring(0, wRes.Name.IndexOf("")).Trim();
                            }
                            //[o sage age ͍폜
                            wRes.Mail = matchCol[0].Groups[2].Value.Trim().Replace("sage", "").Replace("age", "");
                            //,ID𒊏o
                            string dateId = matchCol[0].Groups[3].Value.Trim();
                            if (dateId.IndexOf("ID:") >= 0) {
                                wRes.date = dateId.Substring(0, dateId.IndexOf("ID:")).Trim();
                                //              wRes.date=DateTime.Parse(dateId.Substring(0,dateId.IndexOf("ID:")));
                                wRes.id = dateId.Substring(dateId.IndexOf("ID:") + 3).Trim();
                            }
                            //{o
                            wRes.text = matchCol[0].Groups[4].Value.Trim();
                            //tikage΍
                            if (new System.Text.RegularExpressions.Regex(@"\d{20}").Matches(wRes.text).Count > 0) {
                                wRes.text = "tikage Ǝv̂ō폜܂B";
                            }
                            //milky΍
                            if (wRes.Name.Equals("milky")) {
                                wRes.text = "milky Ǝv̂ō폜܂B";
                            }
                            //N^Ô܂܂ƎזȂ̂ō폜
                            wRes.text = Regex.Replace(wRes.text, "\\<a.*?target=\\\"_blank\\\">(.*?)</a>", "$1");
                            //wRes.text = wRes.text.Replace("</a>", "");
                            //              wRes.text=wRes.text.Replace("</a>","").Replace("<br>","\n").Replace("&gt;",">").Replace("&lt;","<");
                            //Xbh\̂ɒǉ
                            wSure.Res.Add(wRes);
                        }
                    }
                }
                //e[h({Ɏw蕶܂߂Ώo)
                Boolean enforcedMode = System.Configuration.ConfigurationSettings.AppSettings["ENFORCED_MODE"].Equals("TRUE");
                //X[h TRUE:E҂̔ɑ΂郌XE FALSE:E҂̕tX͏E
                Boolean resMode = System.Configuration.ConfigurationSettings.AppSettings["RES_MODE"].Equals("TRUE");
                
                //Xbhe
                //,,ID̂ǂꂩvE҂̔ƂB
                foreach (Res r in wSure.Res) {
                    //UғуXgɂΏO
                    if (brave.DummyTrips.Contains(r.Trip)) {
                        continue;
                    }
                    //UIDXgɂΏO
                    else if (brave.DummyIDs.Contains(r.id)) {
                        continue;
                    }
                    //Ov
                    //̃[hΉ
                    else if ((nameMode.Equals("START") && r.Name.StartsWith(brave.Name))
                        || (nameMode.Equals("IN") && r.Name.IndexOf(brave.Name)>=0)
                        || (nameMode.Equals("ALL") && r.Name.Equals(brave.Name))
                        || (nameMode.Equals("END") && r.Name.EndsWith(brave.Name))
                            ) {
                        r.flag = Res.FLAG_RES;
                    }
                    //шv
                    else if (brave.Trips.Contains(r.Trip)) {
                        r.flag = Res.FLAG_RES;
                    }
                    //IDv
                    else if (brave.IDs.Contains(r.id)) {
                        r.flag = Res.FLAG_RES;
                    }
                    //e[h({Ɏw蕶܂߂Ώo)
                    else if (enforcedMode && r.Name.IndexOf(brave.Name) >= 0) {
                        r.flag = Res.FLAG_OTHER;
                    }
                    //ło͑Ώۂ΃Xbho͑ΏۂɂB
                    if (wSure.flag == 0 && r.flag != Res.FLAG_NO_OUTPUT) {
                        wSure.flag = 1;
                        wSure.date = r.date;
                    }
                }
                //N撊o
                //CȂ̂ŒNYɏl璼Ă(؎)
                if (wSure.flag == 1) {
                    foreach (Res r in wSure.Res) {
                        //E҂̔̃N撊o ̃No
                        if (r.flag == Res.FLAG_RES || r.flag == Res.FLAG_UNC) {
                            //>>x >>xx >>xxx >>1000 𒊏o (>>1͏O)
                            Regex regex = new System.Text.RegularExpressions.Regex(ANCHOR_PATTERN);
                            MatchCollection matchCol = regex.Matches(r.text);
                            //N݂
                            if (matchCol.Count > 0) {
                                foreach (Match match in matchCol) {
                                    try {
                                        //ÑXԉ
                                        int index = ToNumber(match.Groups[2].Value);
                                        int lastIndex = index;
                                        //͈͈Ή
                                        if (match.Groups.Count > 3) {
                                            string separete = match.Groups[3].Value.Trim();
                                            if (separete.Equals("-")) {
                                                lastIndex = ToNumber(match.Groups[4].Value);
                                            }
                                            if (separete.Equals(",")) {
                                                int wIndex = ToNumber(match.Groups[4].Value);
                                                //>>1Ή
                                                if (wIndex > 1 && wIndex < wSure.Res.Count) {
                                                    if (r.No < wSure.Res[wIndex - 1].No || r.flag == Res.FLAG_UNC) {
                                                        SetFlag(wSure.Res[wIndex - 1], Res.FLAG_UNC);
                                                    } else {
                                                        SetFlag(wSure.Res[wIndex - 1], Res.FLAG_OTHER);
                                                    }
                                                }
                                            }
                                        }
                                        //XԂ݂Ώ
                                        for (int i = index; i <= lastIndex; i++) {
                                            //>>1Ή
                                            if (i > 1 && i < wSure.Res.Count) {
                                                if (r.No < wSure.Res[i - 1].No || r.flag == Res.FLAG_UNC) {
                                                    SetFlag(wSure.Res[i - 1], Res.FLAG_UNC);
                                                } else {
                                                    SetFlag(wSure.Res[i - 1], Res.FLAG_OTHER);
                                                }
                                            }
                                        }
                                    } catch (Exception e) {
                                        Console.WriteLine("text={0}\nException StackTrace = {1}", r.text, e.StackTrace);
                                    }
                                }
                            }
                            //Ή i܂Ł͌\E͂
                            if (r.flag == Res.FLAG_UNC) {
                                if (r.text.IndexOf("") >= 0) {
                                    int index = r.No - 1;
                                    if (index > 1 && index < wSure.Res.Count) {
                                        SetFlag(wSure.Res[index - 1], Res.FLAG_UNC);
                                    }
                                }

                                if (r.text.IndexOf("́") >= 0) {
                                    int index = r.No + 2;
                                    if (index > 1 && index < wSure.Res.Count) {
                                        SetFlag(wSure.Res[index - 1], Res.FLAG_UNC);
                                    }
                                } else
                                if (r.text.IndexOf("") >= 0) {
                                    int index = r.No + 1;
                                    if (index > 1 && index < wSure.Res.Count) {
                                        SetFlag(wSure.Res[index - 1], Res.FLAG_UNC);
                                    }
                                }
                            }

                        } else if (resMode) {    //E҂̔ɑ΂郌Xo
                          //XĎwΉ(1̃N͖)
                          if(r.No==1){
                            continue;
                          }
                          //>>x >>xx >>xxx >>1000 𒊏o (>>1͏O)
                            Regex regex = new System.Text.RegularExpressions.Regex(ANCHOR_PATTERN);
                            MatchCollection matchCol = regex.Matches(r.text);
                            if (matchCol.Count > 0) {
                                foreach (Match match in matchCol) {
                                    try {
                                        int index = ToNumber(match.Groups[2].Value);
                                        int lastIndex = index;
                                        //͈͈Ή
                                        if (match.Groups.Count > 3) {
                                            string separete = match.Groups[3].Value.Trim();
                                            if (separete.Equals("-")) {
                                                lastIndex = ToNumber(match.Groups[4].Value);
                                            }
                                            if (separete.Equals(",")) {
                                                int wIndex = ToNumber(match.Groups[4].Value);
                                                if (wIndex > 0 && wIndex < wSure.Res.Count) {
                                                    //NɗE҂̔܂܂Ώo
                                                    if (wSure.Res[wIndex - 1].flag==Res.FLAG_RES) {
                                                        SetFlag(r, Res.FLAG_OTHER);
                                                    }
                                                }
                                            }
                                        }
                                        //XԂ݂Ώ
                                        for (int i = index; i <= lastIndex; i++) {
                                            if (i > 0 && i < wSure.Res.Count) {
                                                //NɗE҂̔܂܂Ώo
                                                if (wSure.Res[i - 1].flag == Res.FLAG_RES) {
                                                    SetFlag(r, Res.FLAG_OTHER);
                                                }
                                            }
                                        }
                                    } catch (Exception e) {
                                        Console.WriteLine("text={0}\nException StackTrace = {1}", r.text, e.StackTrace);
                                        throw new Exception("eLXg͎s", e);
                                    }
                                }
                            }
                        }
                    }
                }
            } catch (Exception e) {
                Console.WriteLine("Exception StackTrace = {0}", e.StackTrace);
                throw new Exception("сAIDos", e);
            } finally {
            }
            return wSure;
        }

        /**
         * ToNumber
         * Spl܂ޕ𐔎ɕϊ
         */
        private static int ToNumber(string oldString) {
            if (oldString==null || oldString.Trim().Equals("")) {
                return 0;
            }
            if (new System.Text.RegularExpressions.Regex(@"[O-X]").Matches(oldString).Count > 0) {
                //SplĂB
                //VisualBasic̊֐ƃRpC̃Nʓ|Ȃ̂Ńx^ŕϊ
                oldString=oldString.Replace("O", "0")
                    .Replace("P", "1")
                    .Replace("Q", "2")
                    .Replace("R", "3")
                    .Replace("S", "4")
                    .Replace("T", "5")
                    .Replace("U", "6")
                    .Replace("V", "7")
                    .Replace("W", "8")
                    .Replace("X", "9");
            }
            try {
                return int.Parse(oldString);
            } catch{
                return 0;
            }
        }
        /**
         * SetFlag
         * tOݒ
         * tOݒ肷郌X,tO
         */
        private static void SetFlag(Res r,int flag) {
            //
            if (r.flag == Res.FLAG_RES) {
                //N悪ɌΏۗE҂ł΃tO͂̂܂
            } else if (r.flag == Res.FLAG_YRES) {
                //N悪ɑE҂ł΃tO͂̂܂
            } else if (r.flag == Res.FLAG_UNC) {
                //N悪Ɉł΃tO͂̂܂
            } else if (r.Trip == null || r.Trip.Equals("")) {
                //N悪юłȂΎwtO𗧂Ă
                r.flag = flag;
            } else {
                //N悪юȂ瑼E҂ƂB
                r.flag = Res.FLAG_YRES;
            }
        }
        /**
         * ReadFile
         * t@CǍ
         * :ǂݍ݃t@C
         * ߂l:t@Ce
        */
        private static string ReadFile(FileInfo pInfo) {
            StreamReader streamReader = null;
            string sure = "";
            try {
                streamReader = new System.IO.StreamReader(pInfo.OpenRead(), System.Text.Encoding.GetEncoding("sjis"));
                sure = streamReader.ReadToEnd();
            } catch (UnauthorizedAccessException e) {
                Console.WriteLine("Exception StackTrace = {0}", e.StackTrace);
                Console.WriteLine("t@C({0})ւ̃ANZXĂ܂B ", pInfo.Name);
            } catch (FileNotFoundException e) {
                Console.WriteLine("Exception StackTrace = {0}", e.StackTrace);
                Console.WriteLine("t@C({0})܂łB ", pInfo.Name);
            } finally {
                if (streamReader != null) {
                    streamReader.Close();
                }
            }
            return sure;
        }
        /**
         * OutHtml
         * HTMLo
         * :ǂݍ݃t@C
         *     :Eҍ\
         *     :Xbh\
        */
        private static void OutHtml(FileInfo pInfo, Brave brave, Sure wSure) {
            StringBuilder buf = MakeHtml(wSure);
            //o̓t@C  ǂݍ񂾃t@C̊gqhtmlɕύX
            //ŏX^CɂĂǂꂾƃt@CɎgȂo(///)
            string outPath = ConfigurationSettings.AppSettings["OUT_PATH"];
            if (outPath == null || outPath.Equals("")) {
                outPath = ".";
            }
            if (!Directory.Exists(outPath)){
                outPath = ".";
            }
            string outName = ConfigurationSettings.AppSettings["OUT_FILENAME"];
            if (outName == null || outName.Equals("")) {
                if (AppendMode) {
                    outName = brave.Name;
                } else {
                    outName = brave.Name + "_" + pInfo.Name.Substring(0, pInfo.Name.Length - 4);
                }
            } else {
                if (AppendMode) {
                    outName = outName;
                } else {
                    outName = outName + logCount.ToString(ConfigurationSettings.AppSettings["OUT_FORMAT"]);
                    logCount++;
                }
            }
            string fileName=outPath + "/" + outName + ".html";
            StreamWriter sw = new StreamWriter(fileName, false,System.Text.Encoding.GetEncoding(932));
            //eׂď
            sw.Write(buf);
            //
            sw.Close();
            //o͓t[h TRUE:Xēt@FALSE:
            Boolean dateMode = System.Configuration.ConfigurationSettings.AppSettings["DATE_MODE"].Equals("TRUE");
            if (dateMode) {
                try {
                    if (wSure.date == null) {
                        //Xēt
                        File.SetLastWriteTime(fileName, DateTime.Parse(wSure.Res[0].date));
                    } else {
                        //ŏ̗E҂̔
                        File.SetLastWriteTime(fileName, DateTime.Parse(wSure.date));
                    }
                }catch{
                    //Exceptionׂ͒
                }
            }
        }

        /**
         * MakeHtml
         * HTMLo
         * :Xbh\
         * ߂l:HTML
        */
        private static StringBuilder MakeHtml(Sure wSure) {
            StringBuilder buf = new StringBuilder();
            if (TagMode) {
                buf.Append("<html><head>\n");
                //OΉ
                buf.Append("<link rel=\"stylesheet\" type=\"text/css\" href=\"");
                buf.Append(ConfigurationSettings.AppSettings["CSS_FILE"]);
                buf.Append("\">\n");
                //            buf.Append(ReadFile(new System.IO.FileInfo(ConfigurationSettings.AppSettings["CSS_FILE"])));
                /*
                buf.Append("        <style type=\"text/css\">\n");
                buf.Append("<!--\n");
                buf.Append("body { font-size: x-small; }\n");
                buf.Append(".res { color: red;\nfont-weight: bold; }\n");
                buf.Append(".unc { font-weight: bold; }\n");
                buf.Append(".yres { color: blue; }\n");

                buf.Append("-->\n");
                buf.Append("</style>\n");
                 */

                buf.Append("</head><body>\n");
            }
            buf.Append("<br><div class=\"tit\">");
            buf.Append(wSure.Title);
            buf.Append("</div><br><br>\n");
            foreach (Res r in wSure.Res) {
                if (r.flag != Res.FLAG_NO_OUTPUT) {
                    buf.Append(r.No);
                    buf.Append(" ");
                    buf.Append(r.Name);
                    if (r.Trip == null || r.Trip.Equals("")) {
                    } else {
                        buf.Append("");
                        buf.Append(r.Trip);
                    }
                    buf.Append("[");
                    buf.Append(r.Mail);
                    buf.Append("] eF");
                    buf.Append(r.date);
                    buf.Append(" ID:");
                    buf.Append(r.id);
                    switch (r.flag) {
                    case Res.FLAG_RES:
                        buf.Append("<div class=\"res\">");
                        break;
                    case Res.FLAG_UNC:
                        buf.Append("<div class=\"unc\">");
                        break;
                    case Res.FLAG_YRES:
                        buf.Append("<div class=\"yres\">");
                        break;
                    case Res.FLAG_OTHER:
                        buf.Append("<div>");
                        break;
                    }
                    buf.Append(r.text);
                    buf.Append("<br></div><br>\n");
                }
            }
            if (TagMode) {
                buf.Append("</body></html>\n");
            }
            return buf;
        }
        /**
         * Brave
         * Eҍ\
         * EҖ,,ID
        */
        private class Brave {
            // settergettergĂ͎̂
            static string Name_;
            public string Name {
                get {
                    return Name_;
                }
                set {
                    Name_ = value;
                }
            }
            //
            public List<string> Trips = new List<string>();
            //ID
            public List<string> IDs = new List<string>();
            //ΏۊO
            public List<string> DummyTrips = new List<string>();
            //ΏۊOID
            public List<string> DummyIDs = new List<string>();
        }
        /**
         * Sure
         * Xbh\
         * X^C,XXg,o̓tO
         */
        class Sure {
            //X^C
            public string Title;
            //Xꗗ
            public List<Res> Res = new List<Res>();
            //o̓tO
            public int flag = 0;
            //t
            public string date=null;
        }
        /**
         * Res
         * X\
         * X,O,,[,t,ID,{,o̓tO
         */
        class Res {
            //o̓tO
            public const int FLAG_NO_OUTPUT = 0;
            public const int FLAG_RES = 1;
            public const int FLAG_UNC = 2;
            public const int FLAG_YRES = 3;
            public const int FLAG_OTHER = 4;

            //name,mail, ID (2006/05/17() 03:19:01.51 ID:),{,X^Cg(擪̂)
            //X
            public int No;
            //O
            public string Name;
            //
            public string Trip;
            //[
            public string Mail;
            //t
            public string date;
            //ID
            public string id;
            //{
            public string text;
            //o̓tO
            public int flag = FLAG_NO_OUTPUT;
        }
    }
}